#------the configfile check------

package provide FR_config 0.2


namespace eval ::FR_config \
{
  namespace export ReadConfig SaveConfig
}


proc ::FR_config::ReadConfig {{nspace ::}} \
{
  upvar ${nspace}::CONFIGFILE CONFIGFILE
  upvar ${nspace}::DEFAULTS DEFAULTS
  upvar ${nspace}::CONFIG CONFIG                      
                                        
  #----the main proc for configfile checks
  if { [file exists [lindex $CONFIGFILE 0]] } \
  {
    source [lindex $CONFIGFILE 0]
  
    foreach Arg [array names DEFAULTS] \
    {
      if { ![info exists CONFIG($Arg)] } \
      {
        set CONFIG($Arg) "$DEFAULTS($Arg)"
      }
    }  
  } else \
  {
    foreach Arg [array names DEFAULTS] \
    {
      set CONFIG($Arg) "$DEFAULTS($Arg)" 
    }
  }
}


proc ::FR_config::SaveConfig {{nspace ::} {WINDOW .}} \
{
  upvar ${nspace}::CONFIGFILE CONFIGFILE
  upvar ${nspace}::DEFAULTS DEFAULTS
  upvar ${nspace}::CONFIG CONFIG
  upvar ${nspace}::ABOUT ABOUT
 
  #---we grab the position and dimension of the main window
  set CONFIG(Geometry) [wm geometry $WINDOW]
 
  #---we write a file with the configuration values
  if { ![catch {set Fid [open [lindex $CONFIGFILE 0] w]}] } \
  { 
    puts $Fid "#$CONFIGFILE"
    puts $Fid "#"
    puts $Fid "# This is the configuration file for the program: $ABOUT(Name)"
    puts $Fid "#"

    foreach Arg [array names CONFIG] \
    {
      puts $Fid "set CONFIG($Arg) \"$CONFIG($Arg)\""   
    } 

    puts $Fid "#"
    puts $Fid "# end"
    close $Fid

    #file attributes [lindex $CONFIGFILE 0] -permissions 0755
  }
}
