#------the configfile check------

package provide FR_config2 0.1


namespace eval ::FR_config2 {
  variable Local;
  namespace export ReadConfig SaveConfig
}


proc ::FR_config2::ReadConfig {ConfigFile {nspace ::}} {
  variable Local;
  
  upvar ${nspace}::DEFAULTS DEFAULTS
  upvar ${nspace}::CONFIG CONFIG                      
  
  # save the name of the configuration file for the save function
  set Local(ConfigFile) $ConfigFile
  
  # the main proc for configfile checks
  if { [file exists [lindex $Local(ConfigFile) 0]] } {
    # read the configuration file
	source [lindex $Local(ConfigFile) 0]
  
    foreach Arg [array names DEFAULTS] {
	  # if the configuration variable doesn't exit in the
	  # configuration file we preset it with its default value
      if { ![info exists CONFIG($Arg)] } {
        set CONFIG($Arg) "$DEFAULTS($Arg)"
      }
    }  
  } else {
    # The configuration file doesn't exist
	foreach Arg [array names DEFAULTS] {
      # we preset all configuration variables with its defaults
	  set CONFIG($Arg) "$DEFAULTS($Arg)" 
    }
  }
}


proc ::FR_config2::SaveConfig {{nspace ::} {WINDOW .}} \
{
  variable Local;
  
  upvar ${nspace}::DEFAULTS DEFAULTS
  upvar ${nspace}::CONFIG CONFIG
  upvar ${nspace}::ABOUT ABOUT
 
  # we grab the position and dimension of the main window
  set CONFIG(Geometry) [wm geometry $WINDOW]
 
  # we write a file with the configuration values
  if { ![catch {set Fid [open [lindex $Local(ConfigFile) 0] w]}] } \
  { 
    puts $Fid "#$Local(ConfigFile)"
    puts $Fid "#"
    puts $Fid "# This is the configuration file for the program: \
	$ABOUT(Name)"
    puts $Fid "#"

    foreach Arg [array names CONFIG] \
    {
      puts $Fid "set CONFIG($Arg) \"$CONFIG($Arg)\""   
    } 

    puts $Fid "#"
    puts $Fid "# end"
    close $Fid

    #file attributes [lindex $CONFIGFILE 0] -permissions 0755
  }
}

