#-----an empty window-----
# -window "the path for this box - absolute necessary"
# -title "set a title for the box (default: "")"

package provide FR_emptyBox 0.1

package require FR_general

namespace eval ::FR_emptyBox \
{
  namespace export Create Show Exit
}


proc ::FR_emptyBox::Create {args} \
{ 
  set Path ""; set Title ""
 
  for {set i 0} {$i < [llength $args]} {incr i 2} \
  {
    set Arg [lindex $args $i]
    switch -glob -- $Arg \
    {
      -window  {set Path [lindex $args [expr {$i+1}]]} \
      -title   {set Title [lindex $args [expr {$i+1}]]} \
      --       {break} \
      *        {puts "Unknown option: $Arg"; exit 1}
    }
  }

   
  if { $Path == "" } \
  {
    puts "You must hand over a valid pathname, not an empty string"; exit 1
  }
 
  set Path [string trimleft $Path .]
  
  if {![winfo exists .$Path]} \
  {
    toplevel .$Path
    wm withdraw .$Path
  }
  
  wm title .$Path $Title

  return $Path
}


proc ::FR_emptyBox::Show {args} \
{ 
  set Path ""; set Parent "."; set Returnvalue ""
 
  for {set i 0} {$i < [llength $args]} {incr i 2} \
  {
    set Arg [lindex $args $i]
    switch -glob -- $Arg \
    {
      -window      {set Path [lindex $args [expr {$i+1}]]} \
      -parent      {set Parent [lindex $args [expr {$i+1}]]} \
      -returnvalue {set Returnvalue [lindex $args [expr {$i+1}]]} \
      --           {break} \
      *            {puts "Unknown option: $Arg"; exit 1}
    }
  }

  if { $Path == ""} \
  {
    puts "You must hand over a valid pathname, not an empty string"; exit 1
  }
 
  set Path [string trimleft $Path .]
 
  ::FR_general::CenterWindow .$Path $Parent
  wm deiconify .$Path
 
  wm protocol .$Path WM_DELETE_WINDOW [list ::FR_emptyBox::Exit $Path $Parent $Returnvalue]
}


proc ::FR_emptyBox::Exit {Path Parent Returnvalue} \
{   
  focus $Parent
  destroy .$Path
  return $Returnvalue
}
